/*
 * cookie.js - store and retrieve cookies.
 *
 * Verlof Web application
 *
 * Copyright (C) 2002-2005, by Leiden University.
 * verlof is free software.  See the file Copying for copying permission.
 *
 * Author: Martin J. Moene
 *
 * $Id: $
 */

/*
 * setCookie - set cookie values. Expiration date is optional.
 */

function setCookie(name, value, expire)
{
   document.cookie = name + "=" + escape(value) + ((expire == null) ? "" : ("; expires=" + expire.toGMTString()))
}

/*
 * getCookie - get cookie value.
 */

function getCookie(name)
{
   var search = name + "=";

   if (document.cookie.length > 0)      // if there are any cookies
   {
      offset = document.cookie.indexOf(search);

      if (offset != -1)                 // if cookie exists
      {
         offset += search.length;

         // set index of beginning of value
         end = document.cookie.indexOf(";", offset);

         // set index of end of cookie value
         if (end == -1)
            end = document.cookie.length;

         return unescape(document.cookie.substring(offset, end));
      }

      return "";
   }

   return "";
}

/*
 * End of file
 */

