#
# mkdbtbl.sql - SQL to create verlof tables
#
# Verlof Web application, Copyright (C) 2002-2005 by Universiteit Leiden.
#
# Author: Martin J. Moene
#
# $Id: mktbl.sql 3 2005-09-05 12:41:54Z moene $
#

#
# Table structure for table 'person'
#

CREATE TABLE person (
   personID  INT    NOT NULL PRIMARY KEY auto_increment,
   name      TEXT   NOT NULL,
   email     TEXT,
   sessionID INT    NOT NULL			# since verlof-0.4.4
);

#
# Table structure for table 'verlof'
#
# part:
#	null
#   vm	voormiddag
#   nm	namiddag
#
# category:
#   v	verlof
#   bv	bijzonder verlof
#   sv	stuwmeer verlof
#   a	ADV
#   va	verplicht ADV
#   t	tegoed
#   at	ADV tegoed
#   tr	transport
#

CREATE TABLE verlof (
   verlofID INT     NOT NULL PRIMARY KEY auto_increment,
   personID INT     NOT NULL,
   date1    DATE    NOT NULL,
   date2    DATE    NOT NULL,
   hours    REAL    NOT NULL,
   part     CHAR(2) DEFAULT NULL,
   category CHAR(3) NOT NULL,
   remark   TEXT    DEFAULT NULL
);

#
# End of file
#

